init()
{
	if(level.ex_bleeding)
	level thread onPlayerConnect(); 
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.bleeding = 0;
		player.bleed_count = 0;

		player thread onPlayerSpawned();
		player thread onPlayerKilled();
		player thread onJoinedTeam();
		player thread onJoinedSpectators();
		player thread onPlayerDisconnect();
	}
}

onJoinedTeam()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_team");
		
	}
}

onJoinedSpectators()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_spectators");
		
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		

		self.bleeding = 0;
		self.bleed_count = 0;
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		

		self.bleeding = 0;
		self.bleed_count = 0;
	}
}

onPlayerDisconnect()
{
	self endon("disconnect");

	self waittill("disconnect");
	
}


playerBleed(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	level endon("game_ended");
	self endon("disconnect");
	self endon ("StopBleeding");
	self endon("spawned");
	self endon("killed_player");

	wait (1 * level.fps_multiplier);

	bleedV = [];
	bleedV = getBleedData(sMeansOfDeath, sWeapon, sHitLoc);

	if(!isDefined(bleedV["bleedmsg"])) return;

	// Do not do friendly damage if friendly damage is off
	if(getDvar("g_gametype") != "dm" && isPlayer(eAttacker) && self != eAttacker && self.pers["team"] == eAttacker.pers["team"])
	{
		if(level.friendlyfire == 0 || level.friendlyfire == 2)
			return;
		if(level.friendlyfire == 3)
		{
			iDamage = int(iDamage * .5);
		}
	}

	if(isPlayer(self))
	{
		if(isalive(self) && (self.health < level.ex_startbleed))

		{
			self.ex_bleeding = true;
			bleedcount = level.ex_maxbleed;

			msg = bleedV["bleedmsg"];

			if(level.ex_bleedmsg_global) switch(level.ex_bleedmsg)
			{
				case 0: self iprintln(msg); break;
				case 1: self iprintlnbold(msg); break;
			}

			while ((bleedcount > 0) && isalive(self) && (self.health < level.ex_startbleed))
			{
				if(self.health > 1)
				{
					self.health--;
					//if(!self.ex_bphockinit) self thread doBleedPainShock();
					 self thread doBleedPainSound();
					//playfxontag(level.ex_effect["bleeding"], self, bleedV["bleedpos"]);
				}
				else self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

				bleedcount--;
				wait (bleedV["bleeddly"] * level.fps_multiplier);
			}

			self.ex_bleeding = false;
			self.ex_bsoundinit = false;
			//self.ex_bphockinit = false;

			if(level.ex_bleedmsg_global && level.ex_bleedmsg && isalive(self) && (self.health > level.ex_startbleed))
			{
				msg = &"BLEED_BLEEDINGSTOPPED";

				switch(level.ex_bleedmsg)
				{
					case 0: self iprintln(msg); break;
					case 1: self iprintlnbold(msg); break;
					//case 2: self thread playerBleedMsg(msg); break;
					//default: self thread extreme\_ex_utils::ex_hud_announce(msg, 0); break;
				}
			}
			else if(!level.ex_bleedmsg && level.ex_bleedmsg_global && isalive(self) && (self.health > level.ex_startbleed)) self iprintln(&"BLEED_BLEEDINGSTOPPED");
		}
	}
}

doBleedPainSound()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon ("StopBleeding");
	self endon("spawned");
	self endon("killed_player");

	if(!level.ex_bleedsound) return;

	self.ex_bsoundinit = true;
	sounddelay = 5.0;

	while(isPlayer(self) && self.sessionstate == "playing" && isdefined(self.ex_bleeding) && (self.health < level.ex_startbleed))
	{
		if(self.health >= 1 && self.health <= 5) sounddelay = 1.0;
		else if(self.health >= 6 && self.health <= 10) sounddelay = 1.5;
		else if(self.health >= 11 && self.health <= 25) sounddelay = 2.0;
		else if(self.health >= 26 && self.health <= 50) sounddelay = 3.0;
		else if(self.health >= 51 && self.health <= 75) sounddelay = 4.0;
		else sounddelay = 5.0;

			self playLocalSound("breathing_hurt");


		wait sounddelay;
	}
}

/*doBleedPainShock()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon ("StopBleeding");
	self endon("spawned");
	self endon("killed_player");

	self.ex_bphockinit = true;
	shocktime = 1;

	while (isalive(self) && isdefined(self.ex_bleeding) && (self.health < level.ex_startbleed))
	{
		if(self.health >= 1 && self.health <= 5) shocktime = 10;
		else if(self.health >= 6 && self.health <= 10) shocktime = 5;
		else if(self.health >= 11 && self.health <= 25) shocktime = 4;
		else if(self.health >= 26 && self.health <= 50) shocktime = 3;
		else if(self.health >= 51 && self.health <= 75) shocktime = 2;

		self shellshock("medical", shocktime);

		wait shocktime + (randomInt(10) + 5);
	}
}*/

/*playerBleedMsg(bleedmsg)
{
	level endon("game_ended");
	self endon("disconnect");
	self endon("spawned");
	self endon("killed_player");
		
	if(!isdefined(self.ex_bleedmsg))
	{
		self.ex_bleedmsg = newClientHudElem(self);
		self.ex_bleedmsg.x = 320;
		self.ex_bleedmsg.y = 420;
		self.ex_bleedmsg.alignX = "center";
		self.ex_bleedmsg.alignY = "middle";
		self.ex_bleedmsg.alpha = 1.0;
		self.ex_bleedmsg.fontScale = 1.4;
	}

	wait (0.5 * level.fps_multiplier);

	if(isdefined(self.ex_bleedmsg))
	{
		self.ex_bleedmsg setText(bleedmsg);
		self.ex_bleedmsg fadeOverTime(2);
		self.ex_bleedmsg.alpha = 1;
	}

	wait (5 * level.fps_multiplier);

	if(isdefined(self.ex_bleedmsg))
	{	
		self.ex_bleedmsg fadeOverTime(2);
		self.ex_bleedmsg.alpha = 0;
	}
}*/

getBleedData(sMeansOfDeath, sWeapon, sHitLoc)
{
	pmsg = undefined;
	delay = undefined;

	switch(sHitLoc)
	{
		case "neck":			pmsg = &"BLEED_NECK"; delay = 0.7; break;
		case "head":			pmsg = &"BLEED_HEAD"; delay = 0.4; break;
		case "helmet":			pmsg = &"BLEED_HELMET"; delay = 0.9; break;
		case "torso_upper":		pmsg = &"BLEED_UPPERTORS"; delay = 1.0; break;
		case "torso_lower":		pmsg = &"BLEED_LOWERTORS"; delay = 1.0; break;
		case "left_leg_upper":		pmsg = &"BLEED_LEFTLEGUP"; delay = 1.2; break;
		case "right_leg_upper":		pmsg = &"BLEED_RIGHTLEGUP"; delay = 1.2; break;
		case "left_leg_lower":		pmsg = &"BLEED_LEFTLEGLOW"; delay = 1.5; break;
		case "right_leg_lower":		pmsg = &"BLEED_RIGHTLEGLOW"; delay = 1.5; break;
		case "left_foot":			pmsg = &"BLEED_LEFTFOOT"; delay = 2.5; break;
		case "right_foot":		pmsg = &"BLEED_RIGHTFOOT"; delay = 2.5; break;
		case "left_arm_upper":		pmsg = &"BLEED_LEFTARMUP"; delay = 1.5; break;
		case "right_arm_upper":		pmsg = &"BLEED_RIGHTARMUP"; delay = 1.5; break;
		case "left_arm_lower":		pmsg = &"BLEED_LEFTARMLOW"; delay = 1.5; break;
		case "right_arm_lower":		pmsg = &"BLEED_RIGHTARMLOW"; delay = 1.5; break;
		case "left_hand":			pmsg = &"BLEED_LEFTHAND"; delay = 2.0; break;
		case "right_hand":		pmsg = &"BLEED_RIGHTHAND"; delay = 2.0; break;

		case "none":
		{
			switch(sMeansOfDeath)
			{
				
				case "MOD_GRENADE": pmsg = &"BLEED_EXPLOSIVE"; break;
				case "MOD_GRENADE_SPLASH": pmsg = &"BLEED_EXPLOSIVE"; break;
				case "MOD_PROJECTILE": pmsg = &"BLEED_PROJECTILE"; break;
				case "MOD_PROJECTILE_SPLASH": pmsg = &"BLEED_PROJECTILE"; break;
				case "MOD_CRUSH": pmsg = &"BLEED_CRUSH"; break;
				case "MOD_EXPLOSIVE": pmsg = &"BLEED_EXPLOSIVE"; break;
				case "MOD_IMPACT": pmsg = &"BLEED_IMPACT"; break;
				case "MOD_FALLING": pmsg = &"BLEED_FALLING"; break;
			}
		}
					
		delay = 2.0;
		break;

		default: pmsg = &"BLEED_DEFAULT"; delay = 2.0; break;
	}

	bleedV["bleedmsg"] = pmsg;
	bleedV["bleeddly"] = delay;
	
	return bleedV;
}
