main()
{	
	//******************************************************************************
	// eXtreme+ setup commonly used function alias
	//******************************************************************************
	level.ex_dvardef = extreme\_ex_utils::dvardef;

	//******************************************************************************
	// eXtreme+ make current gametype and map as level variables
	//******************************************************************************
	level.ex_currentgt = getdvar("g_gametype");
	level.ex_currentmap = getdvar("mapname");
	
	if(level.ex_currentgt != "dm" ) level.ex_teamplay = true;
      else level.ex_teamplay = false;


	//******************************************************************************
	// eXtreme+ forced clientside dvars
	//******************************************************************************
	level.ex_nonadeind = [[level.ex_dvardef]] ("ex_nonadeind", 0, 0, 1, "int");
	level.ex_nocrosshair = [[level.ex_dvardef]] ("ex_nocrosshair", 0, 0, 1, "int");
	level.ex_nomantlehint = [[level.ex_dvardef]] ("ex_nomantlehint", 0, 0, 1, "int");
	level.ex_nodeathicon = [[level.ex_dvardef]] ("ex_nodeathicon", 0, 0, 1, "int");
	level.ex_noredcrosshairs = [[level.ex_dvardef]] ("ex_noredcrosshairs", 0, 0, 1, "int");

	level.ex_crosshairnames = [[level.ex_dvardef]] ("ex_nocrosshairnames", 0, 0, 1, "int");
	level.ex_moveinprematch = [[level.ex_dvardef]] ("ex_moveinprematch", 0, 0, 1, "int");
	level.ex_objective_compasspoints = [[level.ex_dvardef]] ("ex_objective_compasspoints", 0, 0, 1, "int");
	level.ex_objective_floatpoints = [[level.ex_dvardef]] ("ex_objective_floatpoints", 0, 0, 1, "int");
	level.ex_teambalance = [[level.ex_dvardef]] ("ex_teambalance", 1, 0, 1, "int");
	level.ex_hiticon = [[level.ex_dvardef]] ("ex_hiticon", 1, 0, 4, "int");
	
	//****************************************************************************
	// eXtreme+ fix corrupt map rotations
	//****************************************************************************
	level.ex_fixmaprotation = [[level.ex_dvardef]]("ex_fix_maprotation", 0, 0, 1, "int");

	//****************************************************************************
	// eXtreme+ random map rotation
	//****************************************************************************
	level.ex_randommaprotation = [[level.ex_dvardef]]("ex_random_maprotation", 0, 0, 2, "int");
	
	//****************************************************************************
	// eXtreme+ map rotation control
	//****************************************************************************
	//level.ex_pbrotate = [[level.ex_cvardef]]("ex_pbrotate", 0, 0, 1, "int");
	//level.ex_pbrsmall = [[level.ex_cvardef]]("ex_pbrsmall", 0, 0, 64, "int");
	//level.ex_pbrmedium = [[level.ex_cvardef]]("ex_pbrmedium", 0, 0, 64, "int");

	// Rotate map if server is empty?
	if(!isdefined(game["ex_emptytime"])) game["ex_emptytime"] = 0;
	level.ex_rotateifempty = [[level.ex_dvardef]]("ex_rotate_if_empty", 5, 0, 1440, "int");
	
	//****************************************************************************
	// eXtreme+ log file
	//****************************************************************************
	level.ex_logfile = [[level.ex_dvardef]]("ex_log_file", 0, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ player bob factor
	//****************************************************************************
	level.ex_bobfactor = [[level.ex_dvardef]]("ex_player_bobfactor", 0, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ force auto-assign on team menu
	//****************************************************************************
	level.ex_forceauto = [[level.ex_dvardef]]("ex_forceauto", 0, 0, 2, "int");
	//level.ex_menuAutoAssign = [[level.ex_dvardef]] ("ex_menuAutoAssign", 0, 0, 1, "int"); 
	//level.ex_menuspectator = [[level.ex_dvardef]] ("ex_menuspectator", 0, 0, 1, "int"); 
	//level.ex_menuAutoAssign = [[level.ex_dvardef]] ("ex_menuAutoAssign", 0, 0, 1, "int"); 
	//level.ex_menuAllies = [[level.ex_dvardef]] ("ex_menuAllies", 0, 0, 1, "int"); 
	//level.ex_menuAxis = [[level.ex_dvardef]] ("ex_menuAxis", 0, 0, 1, "int"); 

	
	//***************************************************************************
	// eXtreme+ map voting system
	//***************************************************************************
	level.ex_mapvote = [[level.ex_dvardef]]("ex_map_vote", 0, 0, 1, "int");
	if(level.ex_mapvote)
	{
		level.ex_mapvotemax = [[level.ex_dvardef]]("ex_map_vote_max", 10, 5, 50, "int");
		level.ex_mapvotemode = [[level.ex_dvardef]]("ex_map_vote_mode", 0, 0, 3, "int");
		level.ex_mapvotetime = [[level.ex_dvardef]]("ex_map_vote_time", 30, 10, 180, "int");
		level.ex_mapvotereplay = [[level.ex_dvardef]]("ex_map_vote_replay", 0, 0, 1, "int");
		level.ex_ignore_clanvoting = [[level.ex_dvardef]]("ex_ignore_clanvoting", 0, 0, 1, "int");
	}
	else level.ex_mapvotemode = 0;

	//********************************************************************************
	// eXtreme+ healthbar
	//********************************************************************************
	level.ex_healthbar = [[level.ex_dvardef]] ("ex_healthbar", 0, 0, 1, "int");
	level.ex_healthregen = [[level.ex_dvardef]] ("ex_healthregen", 0, 0, 1, "int");
	level.ex_regenmethod = [[level.ex_dvardef]] ("ex_regenmethod", 0, 0, 4, "int");
	
	//****************************************************************************
	// eXtreme+ duplicate name check
	//****************************************************************************
	level.ex_namechecker = [[level.ex_dvardef]]("ex_namechecker", 1, 0, 1, "int");
	level.ex_ncskipwarning = [[level.ex_dvardef]]("ex_ncskipwarning", 1, 0, 1, "int");

	//********************************************************************************
	// eXtreme+ spawnprotection
	//********************************************************************************
	level.ex_spawnprotection = [[level.ex_dvardef]] ("ex_spawnprotection", 0, 0, 120, "int");
	level.ex_spwn_wepdisable = [[level.ex_dvardef]] ("ex_protection_weapon_disable", 0, 0, 1, "int");
	level.invisible_spawnpro = [[level.ex_dvardef]] ("ex_inv_spwn", 0, 0, 1, "int");
	
	//****************************************************************************
	// Server redirection
	//****************************************************************************
	level.ex_redirect = [[level.ex_dvardef]]("ex_redirect", 0, 0, 1, "int");
	level.ex_redirect_ip = [[level.ex_dvardef]]("ex_redirect_ip", "", "", "", "string");
	level.ex_redirect_pause = [[level.ex_dvardef]]("ex_redirect_pause", 10, 5, 60, "int");
	level.ex_redirect_reason = [[level.ex_dvardef]]("ex_redirect_reason", 0, 0, 3, "int");
	level.ex_redirect_logic = [[level.ex_dvardef]]("ex_redirect_logic", 0, 0, 2, "int");
	level.ex_redirect_priority = [[level.ex_dvardef]]("ex_redirect_priority", 0, 0, 4, "int");
	level.ex_redirect_hint = [[level.ex_dvardef]]("ex_redirect_hint", 1, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ announcer - time remaining, score, results, firstblood, player connect
	//****************************************************************************
	level.ex_timeannouncer = [[level.ex_dvardef]]("ex_announcer", 0, 0, 2, "int");
	level.ex_antime = [[level.ex_dvardef]]("ex_antime", 0, 0, 1, "int");
	level.ex_anscore = [[level.ex_dvardef]]("ex_anscore", 0, 0, 1, "int");
	level.ex_anresult = [[level.ex_dvardef]]("ex_anresult", 0, 0, 1, "int");
	//level.ex_firstblood = [[level.ex_dvardef]]("ex_firstblood", 0, 0, 1, "int");
	level.ex_plcdsound = [[level.ex_dvardef]]("ex_plcdsound", 0, 0, 1, "int");

	//****************************************************************************************************************
	// eXtreme+ welcome messages
	//****************************************************************************************************************
	level.ex_pwelcome = [[level.ex_dvardef]] ("ex_pwelcome", 0, 0, 1, "int");
	level.ex_pweldelay = [[level.ex_dvardef]] ("ex_pwelcome_delay", 1, 0, 10, "int");
	level.ex_pwelmsg = [[level.ex_dvardef]] ("ex_pwelcome_msg", 0, 0, 5, "int");
	level.ex_welcomeonea = [[level.ex_dvardef]] ("ex_welcommsgonea", "", "", "", "string"); 
	level.ex_welcomeoneb = [[level.ex_dvardef]] ("ex_welcommsgoneb", "", "", "", "string"); 
	level.ex_welcometwo = [[level.ex_dvardef]] ("ex_welcommsgtwo", "", "", "", "string");
	level.ex_welcomethree = [[level.ex_dvardef]] ("ex_welcommsgthree", "", "", "", "string");
	level.ex_welcomefour = [[level.ex_dvardef]] ("ex_welcommsgfour", "", "", "", "string");
	level.ex_welcomefive = [[level.ex_dvardef]] ("ex_welcommsgfive", "", "", "", "string");
	
	//****************************************************************************
	// eXtreme+ unknown soldier handling system
	//****************************************************************************
	level.ex_uscheck = [[level.ex_dvardef]]("ex_uscheck", 1, 0, 1, "int");
	level.ex_usclanguest = [[level.ex_dvardef]]("ex_usclanguest", 0, 0, 1, "int");
	level.ex_usclanguestname = [[level.ex_dvardef]]("ex_usclanguestname", "Guest#", "" , "", "string");
	level.ex_usguestname = [[level.ex_dvardef]]("ex_usguestname", "UnacceptableName#", "" , "", "string");
	level.ex_uswarndelay1 = [[level.ex_dvardef]]("ex_uswarndelay1", 30, 20, 60, "int");
	level.ex_uswarndelay2 = [[level.ex_dvardef]]("ex_uswarndelay2", 30, 20, 120, "int");
	level.ex_uspunishcount = [[level.ex_dvardef]]("ex_uspunishcount", 5, 1, 999, "int");

	//****************************************************************************************************************
	// eXtreme+ server messages
	//****************************************************************************************************************
	level.ex_svrmsg = [[level.ex_dvardef]] ("ex_svrmsg", 0, 0, 10, "int");
	level.ex_svrmsg_loop = [[level.ex_dvardef]] ("ex_svrmsg_loop", 0, 0, 1, "int");
	level.ex_svrmsg_delay_msg = [[level.ex_dvardef]] ("ex_svrmsg_delay_msg", 30, 1, 60, "int");
	mindef = level.ex_svrmsg * level.ex_svrmsg_delay_msg;
	level.ex_svrmsg_delay_main = [[level.ex_dvardef]] ("ex_server_msg_delay_main", mindef, mindef, 900, "int");
	level.ex_servermsgone = [[level.ex_dvardef]] ("ex_servermsgone", "", "", "", "string");
	level.ex_servermsgtwo = [[level.ex_dvardef]] ("ex_servermsgtwo", "", "", "", "string");
	level.ex_servermsgthree = [[level.ex_dvardef]] ("ex_servermsgthree", "", "", "", "string");
	level.ex_servermsfour = [[level.ex_dvardef]] ("ex_servermsgfour", "", "", "", "string");
	level.ex_servermsgfive = [[level.ex_dvardef]] ("ex_servermsgfive", "", "", "", "string");
	level.ex_servermsgsix = [[level.ex_dvardef]] ("ex_servermsgsix", "", "", "", "string");
	level.ex_servermsgseven = [[level.ex_dvardef]] ("ex_servermsgseven", "", "", "", "string");
	level.ex_servermsgeight = [[level.ex_dvardef]] ("ex_servermsgeight", "", "", "", "string");
	level.ex_servermsgnine = [[level.ex_dvardef]] ("ex_servermsgnine", "", "", "", "string");
	level.ex_servermsgten = [[level.ex_dvardef]] ("ex_servermsgten", "", "", "", "string");
	level.ex_svrmsg_info = [[level.ex_dvardef]]("ex_svrmsg_info", 0, 0, 3, "int");
	level.ex_svrmsg_rotation = [[level.ex_dvardef]]("ex_svrmsg_rotation", 0, 0, 1, "int");
	
	//****************************************************************************************************************
	// eXtreme+ logo
	//****************************************************************************************************************
	level.ex_logo_image = [[level.ex_dvardef]] ("ex_logo", 0, 0, 1, "int");
	level.ex_logo_looptime = [[level.ex_dvardef]] ("ex_logo_looptime", 10, 0, 999, "int");
	level.ex_modlogo = [[level.ex_dvardef]] ("ex_modlogo", 0, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ hud text and settings
	//****************************************************************************
	// Mod Info (bottom-right corner)
	//level.ex_clantext = [[level.ex_dvardef]]("ex_clan_txt",1,0,1,"int");
	level.ex_modtext = [[level.ex_dvardef]]("ex_mod_txt", 1, 0, 1, "int");
	
	//****************************************************************************************************************
	// eXtreme+ laserdot
	//****************************************************************************************************************
	level.ex_laserdot = [[level.ex_dvardef]] ("ex_laserdot", 0, 0, 1, "int");
	
	//****************************************************************************************************************
	// eXtreme+ rangefinder
	//****************************************************************************************************************
	level.ex_rangefinder = [[level.ex_dvardef]]("ex_rangefinder", 0, 0, 1, "int");
	level.ex_rfrange = [[level.ex_dvardef]]("ex_rfunit", 1, 0, 2, "int");
	level.ex_scopeonly = [[level.ex_dvardef]]("ex_scopesonly", 1, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ WMD's
	//****************************************************************************
	level.ex_wmd_uav = [[level.ex_dvardef]]("ex_wmd_uav", 0, 0, 999, "int");
	level.ex_wmd_airstrike = [[level.ex_dvardef]]("ex_wmd_airstrike", 0, 0, 999, "int");
	level.ex_wmd_helicopter = [[level.ex_dvardef]]("ex_wmd_chopper", 0, 0, 999, "int");
	level.ex_wmd_napalm = [[level.ex_dvardef]]("ex_wmd_napalm", 0, 0, 999, "int");

	//****************************************************************************************************************
	// eXtreme+ fall damage
	//****************************************************************************************************************
	if([[level.ex_dvardef]] ("ex_falldamage_enable", 0, 0, 1, "int"))
	{
	setdvar("bg_fallDamageMaxHeight", getdvarint("ex_falldamage_max")*12);
	setdvar("bg_fallDamageMinHeight", getdvarint("ex_falldamage_min")*12);
	}
	
	//****************************************************************************
	// eXtreme+ weapon drop system (after death)
	//****************************************************************************
	// drop grenades
	level.ex_wepo_drop_frags = [[level.ex_dvardef]]("ex_wepo_drop_frag", 0, 0, 1, "int");
	level.ex_wepo_drop_smoke = [[level.ex_dvardef]]("ex_wepo_drop_smoke", 0, 0, 1, "int");
	level.ex_wepo_drop_flash = [[level.ex_dvardef]]("ex_wepo_drop_flash", 0, 0, 1, "int");
	level.ex_wepo_drop_stun = [[level.ex_dvardef]]("ex_wepo_drop_stun", 0, 0, 1, "int");
	level.ex_wepo_drop_all = [[level.ex_dvardef]]("ex_wepo_drop_all", 0, 0, 1, "int");

	//****************************************************************************************************************
	// eXtreme+ jump height
	//****************************************************************************************************************
	if([[level.ex_dvardef]]("ex_jumpheightchange",0,0,1,"int"))
	{
		setdvar("jump_height", getdvarint("ex_jumpheight")*12);
	}

	//****************************************************************************************************************
	// eXtreme+ first aid
	//****************************************************************************************************************
	level.ex_fullhealth = getdvarint("scr_player_maxhealth");
	level.ex_selfheal = [[level.ex_dvardef]]("ex_selfheal", 1, 0, 1, "int");
	level.ex_firstaidkits = [[level.ex_dvardef]]("ex_firstaidkits", 0, 0, 9, "int");
	level.ex_minheal = [[level.ex_dvardef]]("ex_minheal", 40, 1, 99, "int");	
	level.ex_maxheal = [[level.ex_dvardef]]("ex_maxheal", level.ex_minheal + 1, level.ex_minheal + 1, 100, "int");
	level.ex_drophealth = [[level.ex_dvardef]]("ex_drophealth", 0, 0, 1, "int");
	level.ex_firstaidpickup = [[level.ex_dvardef]]("ex_firstaidpickup", 0, 0, 9, "int");	

	
	//****************************************************************************************************************
	// eXtreme+ body sink on death
	//****************************************************************************************************************	
	level.ex_bodysink = [[level.ex_dvardef]] ("ex_bodysink", 0, 0, 1, "int");	

	//****************************************************************************************************************
	// eXtreme+ livestats
	//****************************************************************************************************************
	level.ex_livestats = [[level.ex_dvardef]] ("ex_livestats", 0, 0, 1, "int");
	
	//****************************************************************************
	// eXtreme+ killing spree and obituary system
	//****************************************************************************
 	level.ex_obrange = [[level.ex_dvardef]]("ex_obitunit", 1, 0, 1, "int");
 	level.ex_obituary = [[level.ex_dvardef]]("ex_obituary", 0, 0, 8, "int");
 	level.ex_mononame = [[level.ex_dvardef]]("ex_mononame", 0, 0, 1, "int");	

	//****************************************************************************************************************
	// SV_FPS fix
	//****************************************************************************************************************
	if (getDvarInt("sv_fps") == 30)
	{
		level.fps_multiplier = 1.51382;
		level.frame = .033;
	}
	else if (getDvarInt("sv_fps") == 25)
	{
		level.fps_multiplier = 1.26110;
		level.frame = .039;
	}
	else
	{
		level.fps_multiplier = 1.0;
		level.frame = .05;
		setDvar("sv_fps", "20");
	}

	//****************************************************************************************************************
	// eXtreme+ Weapon damage mod
	//****************************************************************************************************************
	level.ex_wdmodon  = [[level.ex_dvardef]]("ex_wdmodon", 0, 0, 1, "int");
	if(level.ex_wdmodon) thread Weapon_Damage_Mod();
	
	
	//****************************************************************************************************************
	// eXtreme+ Hardpoints // UAV, Airstrike, Helicopter
	//****************************************************************************************************************
	level.ex_hardpoints = [[level.ex_dvardef]]("ex_hardpoints",0, 0, 1, "int");
	

	//*****************************************************************************************************************
	// eXtreme+ bleeding
	//******************************************************************************************************************
	level.ex_bleeding = [[level.ex_dvardef]]("ex_bleeding", 0, 0, 1, "int");
	level.ex_bleedmsg_global = [[level.ex_dvardef]]("ex_bleedmsg_global", 1, 0, 1, "int");
	level.ex_fullhealth = getdvarint("scr_player_maxhealth");

	if(level.ex_bleeding)
	{
		level.ex_startbleed = [[level.ex_dvardef]]("ex_startbleed", 80, 1, 99, "int");
		level.ex_maxbleed = [[level.ex_dvardef]]("ex_maxbleed", 100, 0, 100, "int");
		level.ex_bleedmsg = [[level.ex_dvardef]]("ex_bleedmsg", 0, 0, 1, "int");
		level.ex_bleedsound = [[level.ex_dvardef]]("ex_bleedsound", 0, 0, 1, "int");
	}
	else level.ex_bleedmsg = 0;
	
	//****************************************************************************
	// eXtreme+ anti-camper system
	//****************************************************************************
	level.ex_campwarntime = [[level.ex_dvardef]]("ex_campwarntime", 0, 0, 300, "int");
	level.ex_campobjtime = [[level.ex_dvardef]]("ex_campobjtime", level.ex_campwarntime+10, level.ex_campwarntime+5, 600, "int");
	level.ex_camptimer = [[level.ex_dvardef]]("ex_camptimer", 20, 0, 300, "int");
	level.ex_campsniper_warntime = [[level.ex_dvardef]]("ex_campsniper_warntime", 0, 0, 600, "int");
	level.ex_campsniper_objtime = [[level.ex_dvardef]]("ex_campsniper_objtime", level.ex_campsniper_warntime+10, level.ex_campsniper_warntime+5, 1200, "int");
	level.ex_camppunish = [[level.ex_dvardef]]("ex_camp_punish", 0, 0, 5, "int");

	//****************************************************************************************************************
	// Misc
	//****************************************************************************************************************
	level.ex_showteambalance_msg = [[level.ex_dvardef]]("ex_show_teambalancemsg", 1, 0, 1, "int");
	level.ex_allow_turrets = [[level.ex_dvardef]]("ex_allow_turrets", 1, 0, 1, "int");
 
	
	//*****************************************************************************************************
	// eXtreme+ define level variables
	//*****************************************************************************************************
	level.ex_fbannounce = true;
	level.ex_firstblood = [[level.ex_dvardef]]("ex_firstblood", 0, 0, 1, "int");

	// set up drophealth arrays
	if(level.ex_drophealth)
	{
	    game["ex_healthqueue"] = [];
	    game["ex_healthqueuecurrent"] = 0;

		// Set up object queues
		level.ex_objectQ["health"] = [];
		level.ex_objectQcurrent["health"] = 0;
		level.ex_objectQsize["health"] = 4;
	}

	//***********************************************************************************************************
	// eXtreme+ post-map loadfx, precache strings, shaders, models, headicons
	//***********************************************************************************************************

	// precache shaders
	thread precacheshaders();
	
	// precache models
	thread precachemodels();

	// precache strings
	thread precachestrings();
	
	// precache effects
	thread loadeffects();
}

Weapon_Damage_Mod()
{
	game["ex_wdm"] = [];
	game["ex_wdm"]["ac130_105mm_mp"] = "ex_wdm_ac130";
	game["ex_wdm"]["ac130_25mm_mp"] = "ex_wdm_ac130";
	game["ex_wdm"]["ac130_40mm_mp"] = "ex_wdm_ac130";
	game["ex_wdm"]["airstrike_mp"] = "ex_wdm_airstrike";
	game["ex_wdm"]["ak47_acog_mp"] = "ex_wdm_ak47";
	game["ex_wdm"]["ak47_gl_mp"] = "ex_wdm_ak47";
	game["ex_wdm"]["ak47_mp"] = "ex_wdm_ak47";
	game["ex_wdm"]["ak47_reflex_mp"] = "ex_wdm_ak47";
	game["ex_wdm"]["ak47_silencer_mp"] = "ex_wdm_ak47";
	game["ex_wdm"]["ak74u_acog_mp"] = "ex_wdm_ak74u";
	game["ex_wdm"]["ak74u_mp"] = "ex_wdm_ak74u";
	game["ex_wdm"]["ak74u_reflex_mp"] = "ex_wdm_ak74u";
	game["ex_wdm"]["ak74u_silencer_mp"] = "ex_wdm_ak74u";
	game["ex_wdm"]["artillery_mp"] = "ex_wdm_artillery";
	game["ex_wdm"]["at4_mp"] = "ex_wdm_at4";
	game["ex_wdm"]["aw50_acog_mp"] = "ex_wdm_aw50";
	game["ex_wdm"]["aw50_mp"] = "ex_wdm_aw50";
	game["ex_wdm"]["barrett_acog_mp"] = "ex_wdm_barrett";
	game["ex_wdm"]["barrett_mp"] = "ex_wdm_barrett";
	game["ex_wdm"]["beretta_mp"] = "ex_wdm_beretta";
	game["ex_wdm"]["beretta_silencer_mp"] = "ex_wdm_beretta";
	game["ex_wdm"]["brick_blaster_mp"] = "ex_wdm_brick_bomb";
	game["ex_wdm"]["brick_bomb_mp"] = "ex_wdm_brick_bomb";
	game["ex_wdm"]["c4_mp"] = "ex_wdm_c4";
	game["ex_wdm"]["claymore_mp"] = "ex_wdm_claymore";
	game["ex_wdm"]["cobra_20mm_mp"] = "ex_wdm_cobra";
	game["ex_wdm"]["cobra_ffar_mp"] = "ex_wdm_cobra";
	game["ex_wdm"]["colt45_mp"] = "ex_wdm_colt45";
	game["ex_wdm"]["colt45_silencer_mp"] = "ex_wdm_colt45";
	game["ex_wdm"]["concussion_grenade_mp"] = "ex_wdm_concussion_grenade";
	game["ex_wdm"]["deserteaglegold_mp"] = "ex_wdm_deserteaglegold";
	game["ex_wdm"]["deserteagle_mp"] = "ex_wdm_deserteagle";
	game["ex_wdm"]["destructible_car"] = "ex_wdm_destructible_car";
	game["ex_wdm"]["dragunov_acog_mp"] = "ex_wdm_dragunov";
	game["ex_wdm"]["dragunov_mp"] = "ex_wdm_dragunov";
	game["ex_wdm"]["flash_grenade_mp"] = "ex_wdm_flash_grenade";
	game["ex_wdm"]["frag_grenade_mp"] = "ex_wdm_frag_grenade";
	game["ex_wdm"]["frag_grenade_short_mp"] = "ex_wdm_frag_grenade";
	game["ex_wdm"]["g36c_acog_mp"] = "ex_wdm_g36c";
	game["ex_wdm"]["g36c_gl_mp"] = "ex_wdm_g36c";
	game["ex_wdm"]["g36c_mp"] = "ex_wdm_g36c";
	game["ex_wdm"]["g36c_reflex_mp"] = "ex_wdm_g36c";
	game["ex_wdm"]["g36c_silencer_mp"] = "ex_wdm_g36c";
	game["ex_wdm"]["g3_acog_mp"] = "ex_wdm_g3";
	game["ex_wdm"]["g3_gl_mp"] = "ex_wdm_g3";
	game["ex_wdm"]["g3_mp"] = "ex_wdm_g3";
	game["ex_wdm"]["g3_reflex_mp"] = "ex_wdm_g3";
	game["ex_wdm"]["g3_silencer_mp"] = "ex_wdm_g3";
	game["ex_wdm"]["gl_ak47_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_g36c_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_g3_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_m14_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_m16_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_m4_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["gl_mp"] = "ex_wdm_grenade_launcher";
	game["ex_wdm"]["helicopter_mp"] = "ex_wdm_helicopter";
	game["ex_wdm"]["hind_ffar_mp"] = "ex_wdm_hind_ffar";
	game["ex_wdm"]["humvee_50cal_mp"] = "ex_wdm_humvee_50cal";
	game["ex_wdm"]["m1014_grip_mp"] = "ex_wdm_m1014";
	game["ex_wdm"]["m1014_mp"] = "ex_wdm_m1014";
	game["ex_wdm"]["m1014_reflex_mp"] = "ex_wdm_m1014";
	game["ex_wdm"]["m14_acog_mp"] = "ex_wdm_m14";
	game["ex_wdm"]["m14_gl_mp"] = "ex_wdm_m14";
	game["ex_wdm"]["m14_mp"] = "ex_wdm_m14";
	game["ex_wdm"]["m14_reflex_mp"] = "ex_wdm_m14";
	game["ex_wdm"]["m14_silencer_mp"] = "ex_wdm_m14";
	game["ex_wdm"]["m16_acog_mp"] = "ex_wdm_m16";
	game["ex_wdm"]["m16_gl_mp"] = "ex_wdm_m16";
	game["ex_wdm"]["m16_mp"] = "ex_wdm_m16";
	game["ex_wdm"]["m16_reflex_mp"] = "ex_wdm_m16";
	game["ex_wdm"]["m16_silencer_mp"] = "ex_wdm_m16";
	game["ex_wdm"]["m21_acog_mp"] = "ex_wdm_m21";
	game["ex_wdm"]["m21_mp"] = "ex_wdm_m21";
	game["ex_wdm"]["m40a3_acog_mp"] = "ex_wdm_m40a3";
	game["ex_wdm"]["m40a3_mp"] = "ex_wdm_m40a3";
	game["ex_wdm"]["m4_acog_mp"] = "ex_wdm_m4";
	game["ex_wdm"]["m4_gl_mp"] = "ex_wdm_m4";
	game["ex_wdm"]["m4_mp"] = "ex_wdm_m4";
	game["ex_wdm"]["m4_reflex_mp"] = "ex_wdm_m4";
	game["ex_wdm"]["m4_silencer_mp"] = "ex_wdm_m4";
	game["ex_wdm"]["m60e4_acog_mp"] = "ex_wdm_m60e4";
	game["ex_wdm"]["m60e4_grip_mp"] = "ex_wdm_m60e4";
	game["ex_wdm"]["m60e4_mp"] = "ex_wdm_m60e4";
	game["ex_wdm"]["m60e4_reflex_mp"] = "ex_wdm_m60e4";
	game["ex_wdm"]["mp44_mp"] = "ex_wdm_mp44";
	game["ex_wdm"]["mp5_acog_mp"] = "ex_wdm_mp5";
	game["ex_wdm"]["mp5_mp"] = "ex_wdm_mp5";
	game["ex_wdm"]["mp5_reflex_mp"] = "ex_wdm_mp5";
	game["ex_wdm"]["mp5_silencer_mp"] = "ex_wdm_mp5";
	game["ex_wdm"]["p90_acog_mp"] = "ex_wdm_p90";
	game["ex_wdm"]["p90_mp"] = "ex_wdm_p90";
	game["ex_wdm"]["p90_reflex_mp"] = "ex_wdm_p90";
	game["ex_wdm"]["p90_silencer_mp"] = "ex_wdm_p90";
	game["ex_wdm"]["remington700_acog_mp"] = "ex_wdm_remington";
	game["ex_wdm"]["remington700_mp"] = "ex_wdm_remington";
	game["ex_wdm"]["rpd_acog_mp"] = "ex_wdm_rpd";
	game["ex_wdm"]["rpd_grip_mp"] = "ex_wdm_rpd";
	game["ex_wdm"]["rpd_mp"] = "ex_wdm_rpd";
	game["ex_wdm"]["rpd_reflex_mp"] = "ex_wdm_rpd";
	game["ex_wdm"]["rpg_mp"] = "ex_wdm_rpg";
	game["ex_wdm"]["saw_acog_mp"] = "ex_wdm_saw";
	game["ex_wdm"]["saw_bipod_crouch_mp"] = "ex_wdm_turret";
	game["ex_wdm"]["saw_bipod_prone_mp"] = "ex_wdm_turret";
	game["ex_wdm"]["saw_bipod_stand_mp"] = "ex_wdm_turret";
	game["ex_wdm"]["saw_grip_mp"] = "ex_wdm_saw";
	game["ex_wdm"]["saw_mp"] = "ex_wdm_saw";
	game["ex_wdm"]["saw_reflex_mp"] = "ex_wdm_saw";
	game["ex_wdm"]["skorpion_acog_mp"] = "ex_wdm_skorpion";
	game["ex_wdm"]["skorpion_mp"] = "ex_wdm_skorpion";
	game["ex_wdm"]["skorpion_reflex_mp"] = "ex_wdm_skorpion";
	game["ex_wdm"]["skorpion_silencer_mp"] = "ex_wdm_skorpion";
	game["ex_wdm"]["smoke_grenade_mp"] = "ex_wdm_smoke_grenade";
	game["ex_wdm"]["usp_mp"] = "ex_wdm_usp";
	game["ex_wdm"]["usp_silencer_mp"] = "ex_wdm_usp";
	game["ex_wdm"]["usp_acog_mp"] = "ex_wdm_usp";
	game["ex_wdm"]["uzi_acog_mp"] = "ex_wdm_uzi";
	game["ex_wdm"]["uzi_mp"] = "ex_wdm_uzi";
	game["ex_wdm"]["uzi_reflex_mp"] = "ex_wdm_uzi";
	game["ex_wdm"]["uzi_silencer_mp"] = "ex_wdm_uzi";
	game["ex_wdm"]["winchester1200_grip_mp"] = "ex_wdm_winchester";
	game["ex_wdm"]["winchester1200_mp"] = "ex_wdm_winchester";
	game["ex_wdm"]["winchester1200_reflex_mp"] = "ex_wdm_winchester";
}

precacheshaders()
{
 	// healthbar
	if(level.ex_healthbar)
	{
		precacheShader( "progress_bar_fg" );
		precacheShader( "progress_bar_fill" );
		precacheShader( "hint_health" );
	}

	// laserdot
	if(level.ex_laserdot)
	{
		precacheShader("compassping_enemyfiring");
		precacheShader( "lazedot_orange" ); 
		precacheShader( "lazerdot_blue" ); 
		precacheShader( "lazerdot_liteorange" ); 
		precacheShader( "lazerdot_red" ); 
		precacheShader( "lazeerdot_liteblue" );
		precacheShader( "lazerdot_green" );
		precacheShader( "lazerdot_purple" ); 
		precacheShader( "lazerdot_yellow" );
	}

	// firstaid
	if(level.ex_selfheal)
		precacheShader("hint_health");

	// spawnprotection
	if(level.ex_spawnprotection)
		precacheShader("hint_health");
	
	// eXtreme+ logo
	if(level.ex_logo_image)
		precacheShader("extremelogo");
	
	if(level.ex_campwarntime >= 1)
	{
		precacheShader("objpoint_radio");
		precacheShader("field_radio");
	}
	
	precacheShader("compass_waypoint_target");
	
	precacheShader("compassping_enemyfiring");
	
	game["logo"] = "logo1";
	precacheShader(game["logo"]);
	
	precacheShader( "faction_128_sas" ); 
	precacheShader( "faction_128_usmc" ); 
	precacheShader( "faction_128_ussr" ); 
	precacheShader( "faction_128_arab" ); 
}

precachemodels()
{
	if(level.ex_drophealth)
	{
		PrecacheModel("perc_juggernaut");
	}
}

precachestrings()
{
	// Bleeding
	if(level.ex_bleedmsg)
	{
		PrecacheString(&"BLEED_NECK");
		PrecacheString(&"BLEED_HEAD");
		PrecacheString(&"BLEED_HELMET");
		PrecacheString(&"BLEED_UPPERTORS");
		PrecacheString(&"BLEED_LOWERTORS");
		PrecacheString(&"BLEED_LEFTLEGUP");
		PrecacheString(&"BLEED_RIGHTLEGUP");
		PrecacheString(&"BLEED_LEFTLEGLOW");
		PrecacheString(&"BLEED_RIGHTLEGLOW");
		PrecacheString(&"BLEED_LEFTFOOT");
		PrecacheString(&"BLEED_RIGHTFOOT");
		PrecacheString(&"BLEED_LEFTARMUP");
		PrecacheString(&"BLEED_RIGHTARMUP");
		PrecacheString(&"BLEED_LEFTARMLOW");
		PrecacheString(&"BLEED_RIGHTARMLOW");
		PrecacheString(&"BLEED_LEFTHAND");
		PrecacheString(&"BLEED_RIGHTHAND");
		PrecacheString(&"BLEED_CRUSH");
		PrecacheString(&"BLEED_EXPLOSIVE");
		PrecacheString(&"BLEED_IMPACT");
		PrecacheString(&"BLEED_FALLING");
		PrecacheString(&"BLEED_DEFAULT");
		PrecacheString(&"BLEED_BLEEDINGSTOPPED");
		PrecacheString(&"BLEED_PROJECTILE");
	}

	// Rangefinder
	if(level.ex_rangefinder)
	{
		PrecacheString(&"MISC_RANGE");
		PrecacheString(&"MISC_RANGE2");
	} 

	// Spawnprotection
	if(level.ex_spawnprotection)
	{
		PrecacheString(&"MISC_SPAWNPRO");
	}
	
	// Hardpoints
	if(level.ex_hardpoints)
	{
		PrecacheString(&"EXTREME_EARNED_UAV");
		PrecacheString(&"EXTREME_EARNED_AIRSTRIKE");
		PrecacheString(&"EXTREME_EARNED_HELICOPTER");
		PrecacheString(&"EXTREME_EARNED_NAPALM");
	}
	
	// extreme modlogo
	if(level.ex_modlogo)
	{
		game["strings"]["ex_HUD_website"] = &"EXTREME_MOD";
	}
	
	// Voting
	//if(level.voteLimit)
	//{
		PrecacheString(&"MISC_ENABLED");
		PrecacheString(&"MISC_DISABLED");
		PrecacheString(&"MISC_DELAY");
		PrecacheString(&"MISC_MINUTES");
	//}
	
	// Server redirection
	if(level.ex_redirect)
	{
		PrecacheString(&"REDIRECT_TITLE");
		PrecacheString(&"REDIRECT_TIMELEFT");
		PrecacheString(&"REDIRECT_REASON_ISPRIVATE");
		PrecacheString(&"REDIRECT_REASON_ISFULL");
		PrecacheString(&"REDIRECT_REASON_ISOLD");
		PrecacheString(&"REDIRECT_REASON_ISSERVICED");
		PrecacheString(&"REDIRECT_REASON_CLANPRIORITY");
		PrecacheString(&"REDIRECT_CLAN_FREEUPSLOT");
		PrecacheString(&"REDIRECT_CLAN_ABORTED");
		PrecacheString(&"REDIRECT_CLAN_PLEASEWAIT");
		PrecacheString(&"REDIRECT_CLAN_CONTINUE");
		PrecacheString(&"REDIRECT_TO_PUBLICSERVER");
		PrecacheString(&"REDIRECT_TO_OTHERSERVER");
		PrecacheString(&"REDIRECT_TO_NEWSERVER");
		PrecacheString(&"REDIRECT_HINT_REMFROMFAV");
		PrecacheString(&"REDIRECT_HINT_ADDTOFAV");
		PrecacheString(&"REDIRECT_HINT_VISITWEBSITE");
		PrecacheString(&"REDIRECT_HINT_SORRY");
		PrecacheString(&"REDIRECT_HINT_PRIORITY");
		PrecacheString(&"REDIRECT_HINT_EXTREME");
	}	
	
	// mod text
	if(level.ex_modtext)
	{
		PrecacheString(&"MOD_MESSAGE_NAME");
		PrecacheString(&"MOD_MESSAGE_BY");
		PrecacheString(&"MOD_MESSAGE_WEBSITE");
	}
	
	//Unknownsolider
		PrecacheString(&"UNKNOWNSOLDIER_MSG_UNACCEPTABLE");
		PrecacheString(&"UNKNOWNSOLDIER_MSG_TEMPORARY");
		PrecacheString(&"UNKNOWNSOLDIER_MSG_CHANGEIT");
		PrecacheString(&"UNKNOWNSOLDIER_MSG_CLANGUEST");
		PrecacheString(&"UNKNOWNSOLDIER_MSG_GUEST");
		PrecacheString(&"UNKNOWNSOLDIER_NEWNAME_BYSERVER");
		PrecacheString(&"UNKNOWNSOLDIER_NEWNAME_CLANGUEST");
		PrecacheString(&"UNKNOWNSOLDIER_NEWNAME_GUEST");
		PrecacheString(&"UNKNOWNSOLDIER_NEWNAME_CHANGEIT");
		PrecacheString(&"UNKNOWNSOLDIER_STILL_PUNISH");
		PrecacheString(&"UNKNOWNSOLDIER_STILL_RELIEF1");
		PrecacheString(&"UNKNOWNSOLDIER_STILL_RELIEF2");
		PrecacheString(&"UNKNOWNSOLDIER_MSG_THANKS");
		
	//if(level.ex_mapvote || level.ex_svrmsg_info)
	//{
		// Pre-cache strings for map announcement system
		PrecacheString(&"MAPROTATION_CUSTOM_NEXT");
		PrecacheString(&"MAPROTATION_NEXT_MAP");
		PrecacheString(&"MAPROTATION_NEXT_GT");
		PrecacheString(&"MAPROTATION_TITLE");

		// Pre-cache game types for extended map voting system
		PrecacheString(&"MAPS_DEATHMATCH");
		PrecacheString(&"MAPS_DOMINATION");
		PrecacheString(&"MAPS_KING_OF_THE_HILL");
		PrecacheString(&"MAPS_SABATOGE");
		PrecacheString(&"MAPS_SEARCH_AND_DESTROY");
		PrecacheString(&"MAPS_TEAM_DEATHMATCH");
		PrecacheString(&"MAPS_CAPTURE_THE_FLAG");

		// Pre-cache game type abbreviations for extended map voting system
		PrecacheString(&"MAPS_DM");
		PrecacheString(&"MAPS_DOM");
		PrecacheString(&"MAPS_KOTH");
		PrecacheString(&"MAPS_SAB");
		PrecacheString(&"MAPS_SD");
		PrecacheString(&"MAPS_WAR");
		PrecacheString(&"MAPS_CTF");
	//}
	
		PrecacheString(&"FIRSTBLOOD_REPORT_ALL");
		PrecacheString(&"FIRSTBLOOD_REPORT_SELF");
		PrecacheString(&"FIRSTBLOOD_VICTIM");
		PrecacheString(&"FIRSTBLOOD_VICTIM_TEAM_MATE");
		PrecacheString(&"FIRSTBLOOD_VICTIM_SELF");
		
		//Map rotation system
		PrecacheString(&"MAPS_DEATHMATCH");
		PrecacheString(&"MAPS_DOMINATION");
		PrecacheString(&"MAPS_KING_OF_THE_HILL");
		PrecacheString(&"MAPS_SABATOGE");
		PrecacheString(&"MAPS_SEARCH_AND_DESTROY");
		PrecacheString(&"MAPS_TEAM_DEATHMATCH");
		PrecacheString(&"MAPS_CAPTURE_THE_FLAG");
		PrecacheString(&"MAPS_DM");
		PrecacheString(&"MAPS_DOM");
		PrecacheString(&"MAPS_KOTH");
		PrecacheString(&"MAPS_SAB");
		PrecacheString(&"MAPS_SD");
		PrecacheString(&"MAPS_WAR");
		PrecacheString(&"MAPS_CTF");
		PrecacheString(&"MPUI_BACKLOT");
		PrecacheString(&"MPUI_BLOC");
		PrecacheString(&"MPUI_BOG");
		PrecacheString(&"MPUI_CARGOSHIP");
		PrecacheString(&"MPUI_CITYSTREETS");
		PrecacheString(&"MPUI_CONVOY");
		PrecacheString(&"MPUI_COUNTDOWN");
		PrecacheString(&"MPUI_CRASH");
		PrecacheString(&"MPUI_CRASH_SNOW");
		PrecacheString(&"MPUI_CROSSFIRE");
		PrecacheString(&"MPUI_FARM");
		PrecacheString(&"MPUI_OVERGROWN");
		PrecacheString(&"MPUI_PIPELINE");
		PrecacheString(&"MPUI_SHIPMENT");
		PrecacheString(&"MPUI_SHOWDOWN");
		PrecacheString(&"MPUI_STRIKE");
		PrecacheString(&"MPUI_VACANT");
		PrecacheString(&"MAPROTATION_RANDOM");
		PrecacheString(&"MAPROTATION_PLAYER");
		PrecacheString(&"MAPROTATION_VOTING");
		PrecacheString(&"MAPROTATION_NEXT_MAP");
		PrecacheString(&"MAPROTATION_CUSTOM_NEXT");
		PrecacheString(&"MAPROTATION_NEXT_GT");
		PrecacheString(&"MAPROTATION_TITLE");
		PrecacheString(&"COLOUR_GREEN");
		PrecacheString(&"COLOUR_WHITE");
		PrecacheString(&"COLOUR_WHITE");
		PrecacheString(&"MISC_BLANK_LINE_TXT");
		PrecacheString(&"CUSTOM_SERVER_NAME");
		
		PrecacheString(&"FIRSTAID_PICKEDUP");
	}

loadeffects()
{
	//napalm
	level.napalmfx = loadfx ("extreme_napalm/napalm");
	
	//fart
	level.ex_fartbomb = loadfx("fart/fart_smoke");
	
	//blow the fag
	if((!level.ex_camppunish || level.ex_camppunish == 2)) level.ex_blowthefag = loadfx("explosions/wall_explosion_pm_a");
}