#include extreme\_ex_weapons;

main(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	self.ex_obmonamsg = false;
	self.ex_obmonpmsg = false;
	self.ex_obmonpsound = false;

	// no obituary - with stats
	if(level.ex_obituary == 0) thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);

	// stock obituary	 - with stats
	if(level.ex_obituary == 1)
	{
		obituary(self, attacker, sWeapon, sMeansOfDeath);
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// stock obituary - with stats, personal sounds	
	if(level.ex_obituary == 2)
	{
		obituary(self, attacker, sWeapon, sMeansOfDeath);
		self.ex_obmonpsound = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// stock obituary - with stats, personal messages
	if(level.ex_obituary == 3)
	{
		obituary(self, attacker, sWeapon, sMeansOfDeath);
		self.ex_obmonpmsg = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// stock obituary - with stats, personal sounds, personal messages
	if(level.ex_obituary == 4)
	{
		obituary(self, attacker, sWeapon, sMeansOfDeath);
		self.ex_obmonpmsg = true;
		self.ex_obmonpsound = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// eXtreme+ obituary - with stats 
	if(level.ex_obituary == 5)
	{
		self.ex_obmonamsg = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// eXtreme+ obituary - with stats, personal sounds
	if(level.ex_obituary == 6)
	{
		self.ex_obmonamsg = true;
		self.ex_obmonpsound = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// eXtreme+ obituary, level messages, personal message and stats
	if(level.ex_obituary == 7)
	{
		self.ex_obmonamsg = true;
		self.ex_obmonpmsg = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}

	// eXtreme+ obituary, level messages, personal messages, personal sounds and stats
	if(level.ex_obituary == 8)
	{
		self.ex_obmonamsg = true;
		self.ex_obmonpmsg = true;
		self.ex_obmonpsound = true;
		thread extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	}
}

extremeobituary(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	// unknown death
	if(sMeansOfDeath == "MOD_TRIGGER_HURT") obitnad("unknown",undefined,false);

	// sMeansOfDeath conversion
	if(sMeansOfDeath == "MOD_EXPLOSIVE" && sWeapon == "artillery_mp") sMeansOfDeath = "MOD_ARTILLERY";
	if(sMeansOfDeath == "MOD_GRENADE" && sWeapon == "mortar_mp") sMeansOfDeath = "MOD_MORTAR";
	if(sMeansOfDeath == "MOD_GRENADE" && sWeapon == "planebomb_mp") sMeansOfDeath = "MOD_AIRSTRIKE";
	if(sMeansOfDeath == "MOD_PROJECTILE" && sWeapon == "planebomb_mp") sMeansOfDeath = "MOD_NAPALM";
	if(sMeansOfDeath == "MOD_EXPLOSIVE" && sWeapon == "tripwire_mp") sMeansOfDeath = "MOD_TRIPWIRE";
	if(sMeansOfDeath == "MOD_PROJECTILE" && sWeapon == "panzerschreck_mp") sMeansOfDeath = "MOD_PANZER";
      if(sMeansOfDeath == "MOD_PROJECTILE" && sWeapon == "panzerschreck_allies") sMeansOfDeath = "MOD_PANZER";
 
	//logprint("Means: " + sMeansOfDeath + "Weapon: " + sWeapon + "Hitloc: " + sHitLoc);

	if(isDefined(attacker) && !isPlayer(attacker)) // ambient fx deaths
	{
		switch(sMeansOfDeath)
		{
			case "MOD_EXPLOSIVE":
			{
				switch(sWeapon)
				{
					case "mortar_mp":
					obitnad("mortar","mortardeath",false);
					break;
					
					case "plane_mp":
					obitnad("plane","planedeath",false);
					break;
					
					case "planebomb_mp":
					obitnad("plane_bomb","airstrikedeath",false);
					break;

					default: // minefield death
					obitnad("minefield","minefielddeath",true);
					break;
				}
			}
		}
	}
	else if(isDefined(attacker) && isPlayer(attacker)) // real player kills/deaths
	{
		if(attacker == self) // killed themself
		{
			switch(sMeansOfDeath)
			{
				case "MOD_FALLING":
				obitnad("falling","fallingdeath",true);
				break;

				case "MOD_GRENADE_SPLASH":
				if(isWeaponType(sWeapon, "grenade")) obitnad("selfnade","grenadedeath",false);
				break;

				case "MOD_ARTILLERY":
				obitnad("selfartillery", "artillerydeath", false);
				break;

				case "MOD_MORTAR":
				obitnad("selfmortar", "mortardeath", false);
				break;

				case "MOD_AIRSTRIKE":
				obitnad("selfairstrike", "airstrikedeath", false);
				break;

				case "MOD_NAPALM":
				obitnad("selfnapalm", "napalmdeath", false);
				break;

				case "MOD_PANZER":
				obitmain(attacker,sWeapon,sHitLoc);
				break;

				case "MOD_TRIPWIRE":
				obitnad("selftripwire", "tripwiredeath", false);
				break;

				case "SUICIDE":
				obitnad("selfnades","grenadedeath",true);
				break;
			}
		}
		else if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay) // did not kill themself
		{
			if(isMeansOfDeath(sMeansOfDeath)) // special sMOD
			{
				switch(sMeansOfDeath)
				{
					case "MOD_MELEE":
					{
						if(sHitLoc == "head")	obitad(attacker,"bashkill","bashdeath","bashkill_head", sMeansOfDeath, sWeapon);
						else obitad(attacker,"bashkill","bashdeath","bashkill", sMeansOfDeath, sWeapon);

						break;
					}

					case "MOD_GRENADE_SPLASH":
					{
						if(isWeaponType(sWeapon, "grenade"))
						{
							obitspec(attacker,"grenadekill","explosive","grenadedeath",&"OBITUARY_WITH_A_GRENADE");
							break;
						}
					}

					case "MOD_ARTILLERY":
					obitspec(attacker,"artillerykill","artillery","artillerydeath",&"OBITUARY_WITH_ARTILLERY");
					break;

					case "MOD_MORTAR":
					obitspec(attacker,"mortarkill","pmortar","mortardeath",&"OBITUARY_WITH_MORTAR");
					break;

					case "MOD_AIRSTRIKE":
					obitspec(attacker,"airstrikekill","pairstrike","airstrikedeath",&"OBITUARY_WITH_AIRSTRIKE");
					break;

					case "MOD_NAPALM":
					obitspec(attacker,"napalmkill","pnapalm","napalmdeath",&"OBITUARY_WITH_NAPALM");
					break;

					case "MOD_PANZER":
					obitmain(attacker,sWeapon,sHitLoc);
					break;

					case "MOD_TRIPWIRE":
					obitspec(attacker,"tripwirekill","tripwire","tripwiredeath",&"OBITUARY_WITH_TRIPWIRE");
					break;

					case "MOD_HEAD_SHOT":
					if(isWeaponType(sWeapon, "sniper"))
					{
						self.pers["headshotdeath"]++;
						attacker.pers["headshotkill"]++;
                                                obitmain(attacker,sWeapon,sHitLoc);
						if(self.ex_obmonpmsg) attacker iprintlnbold(&"EXTREME_HEADSHOT");
						if(self.ex_obmonpsound) attacker playLocalSound("headshot");
						break;
					}
					else
					{
						obitad(attacker,"headshotkill","headshotdeath",undefined, sMeansOfDeath, sWeapon);
                                                                                                obitmain(attacker,sWeapon,sHitLoc);
						if(self.ex_obmonpmsg) attacker iprintlnbold(&"EXTREME_HEADSHOT");
						if(self.ex_obmonpsound) attacker playLocalSound("headshot");
						break;
					}

				}
			}
			else // not special sMOD
			{
				// sniper kills
				if(isWeaponType(sWeapon, "sniper")) obitad(attacker,"sniperkill","sniperdeath",undefined, sMeansOfDeath, sWeapon);
                                
			}
		}
		else if(attacker.pers["team"] == self.pers["team"] && level.ex_teamplay) // team kills
		{
			if(isMeansOfDeath(sMeansOfDeath)) // special sMOD
			{
				switch(sMeansOfDeath)
				{
					case "MOD_MELEE":
			 		obitteam(attacker,"bashtk", sMeansOfDeath, sWeapon);
			 		break;

					case "MOD_GRENADE_SPLASH":
					obitspec(attacker,undefined,"explosivetk", "grenadedeath",&"OBITUARY_WITH_A_GRENADE");
					break;

					case "MOD_ARTILLERY":
					obitspec(attacker,undefined,"artillerytk","artillerydeath",&"OBITUARY_WITH_ARTILLERY");
					break;

					case "MOD_MORTAR":
					obitspec(attacker,undefined,"mortartk", "mortardeath",&"OBITUARY_WITH_MORTAR");
					break;

					case "MOD_AIRSTRIKE":
					obitspec(attacker,undefined,"airstriketk", "airstrikedeath",&"OBITUARY_WITH_AIRSTRIKE");
					break;

					case "MOD_NAPALM":
					obitspec(attacker,undefined,"napalmtk", "napalmdeath",&"OBITUARY_WITH_NAPALM");
					break;

					case "MOD_PANZER":
					obitteam(attacker,"headshottk", sMeansOfDeath, sWeapon);
					break;

					case "MOD_TRIPWIRE":
					if(level.ex_tweapon != 2) obitspec(attacker,undefined,"tripwiretk",undefined,&"OBITUARY_WITH_TRIPWIRE");
					else obitspec(attacker,undefined,"tripwiretk", "tripwiredeath",&"OBITUARY_WITH_TRIPWIRE");
					break;

					case "MOD_HEADSHOT":
					obitteam(attacker,"headshottk", sMeansOfDeath, sWeapon);
					break;
	
				}
			}
			else // not special sMOD
			{
				if(isWeaponType(sWeapon, "sniper")) obitteam(attacker,"snmsgtk", sMeansOfDeath, sWeapon);
				else obitteam(attacker,"teamkill", sMeansOfDeath, sWeapon);

				sMeansOfDeath = "MOD_IGNORE";
			}
		}
	}

	// standard deaths
	if(sHitLoc != "none" && !isWeapon(sWeapon) && !isMeansOfDeath(sMeansOfDeath) && isPlayer(attacker))
	{
		if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay) obitmain(attacker,sWeapon,sHitLoc);
		else if(attacker.pers["team"] == self.pers["team"] && attacker != self && level.ex_teamplay) obitteam(attacker,"teamkill", sMeansOfDeath, sWeapon);
	}
	
	self thread killspree(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	if(!isWeaponType(sWeapon, "smg")) self thread weaponstreak(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	if(isWeaponType(sWeapon, "smg")) self thread noobstreak(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
	self thread consecdeath(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc);
}			

isWeapon(sWeapon)
{
	switch(sWeapon)
	{
		case "mortar_mp":
		case "plane_mp":
		case "planebomb_mp":
		case "tripwire_mp":
		case "panzerschreck_mp":
		case "panzerschreck_allies":
		return true;
	}
	
	return false;
}

isMeansOfDeath(sMeansOfDeath)
{
	switch(sMeansOfDeath)
	{
		case "MOD_MELEE":
		case "MOD_GRENADE":
		case "MOD_GRENADE_SPLASH":
		case "MOD_EXPLOSIVE":
		case "MOD_SUICIDE":
		case "MOD_IGNORE":
		case "MOD_ARTILLERY":
		case "MOD_MORTAR":
		case "MOD_AIRSTRIKE":
		case "MOD_NAPALM":
		case "MOD_TRIPWIRE":
		case "MOD_HEAD_SHOT":
		case "MOD_PROJECTILE":
		case "MOD_PANZER":
		return true;
	}
	
	return false;
}

// special detection no attacker defined
obitnad(amsg,vartype,sewyside)
{
	self endon("disconnect");
	if(!isDefined(self.pers["vartype"]))  self.pers["vartype"] = 0 ; 
	if(isDefined(vartype)) self.pers["vartype"]++;
	if(sewyside) self.pers["suicide"]++;

	if(isDefined(amsg))
	{
		if(self.ex_obmonpmsg) self showpmsgs(amsg);
		if(self.ex_obmonamsg) iprintln(getmessage(amsg), self.name);
	}
}

// special detection attacker defined
obitad(attacker, atvt, vivt, amsg, sMeansOfDeath, sWeapon) // atvt, vivt, 
{
	self endon("disconnect");

	//if(isDefined(atvt)) attacker.pers[atvt]++;
	//if(isDefined(vivt)) self.pers[vivt]++;

	if(isDefined(amsg))
	{
		weapon = getweaponstringname(sWeapon);
		
		if(sMeansOfDeath == "MOD_MELEE")
		{
			if(isWeaponType(sWeapon, "pistol"))
			{
				if(self.ex_obmonpmsg) self showpmsgs("pistol_whip");
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage("pistolwhip"), self.name);
					iprintln(&"OBITUARY_USING", attacker.name, weapon);
				}
			}
			else if(isWeaponType(sWeapon, "knife"))
			{
				if(self.ex_obmonpmsg) self showpmsgs("knife_whip");
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage("knifewhip"), self.name);
					iprintln(&"OBITUARY_USING", attacker.name, weapon);
				}
			}
			else
			{
				if(self.ex_obmonpmsg) self showpmsgs(amsg);
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage(amsg), self.name);
					iprintln(&"OBITUARY_USING_BUTT", attacker.name, weapon);
				}
			}

		}
		else
		{
			if(self.ex_obmonpmsg) self showpmsgs(amsg);
			if(self.ex_obmonamsg)
			{
				iprintln(&"OBITUARY_HAS_BEEN_KILLED", self.name);
				iprintln(getmessage(amsg), attacker.name);
			}
		}
	}
}

// killed by team mate
obitteam(attacker,amsg, sMeansOfDeath, sWeapon)
{
	self endon("disconnect");

	if(isDefined(amsg))
	{
		weapon = getweaponstringname(sWeapon);
	
		if(sMeansOfDeath == "MOD_MELEE")
		{
			if(isWeaponType(sWeapon, "pistol"))
			{
				if(self.ex_obmonpmsg) self showpmsgs("pistolwhiptk");
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage("pistolwhiptk"), self.name);
					iprintln(&"OBITUARY_USING", attacker.name, weapon);
				}
			}
			else if(isWeaponType(sWeapon, "knife"))
			{
				if(self.ex_obmonpmsg) self showpmsgs("knifewhiptk");
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage("knifewhiptk"), self.name);
					iprintln(&"OBITUARY_USING", attacker.name, weapon);
				}
			}
			else
			{
				if(self.ex_obmonpmsg) self showpmsgs(amsg);
				if(self.ex_obmonamsg)
				{
					iprintln(getmessage(amsg), self.name);
					iprintln(&"OBITUARY_USING_BUTT", attacker.name, weapon);
				}
			}
		}
		else
		{
			if(self.ex_obmonpmsg) self showpmsgs(amsg);
			if(self.ex_obmonamsg)
			{
				iprintln(getmessage(amsg), self.name);
				iprintln(&"OBITUARY_USING", attacker.name, weapon);
			}
		}
	}
}

// handles weapon_gramatic of mass destruction deaths
obitspec(attacker, atvt, vivt, amsg, wmd) // atvt, vivt, 
{
	self endon("disconnect");

	//if(isDefined(atvt)) attacker.pers[atvt]++;
	//if(isDefined(vivt)) self.pers[vivt]++;

	if(isDefined(amsg))
	{
		if(self.ex_obmonpmsg) self showpmsgs(amsg);

		if(self.ex_obmonamsg)
		{
			iprintln(getmessage(amsg), self.name);
			iprintln(wmd, attacker.name);
		}
	}
}

// standard weapons
obitmain(attacker,sWeapon,sHitLoc)
{
	self endon("disconnect");

	if(!self.ex_obmonamsg) return;

	close = false;
	rangedist = undefined;
	inyards = false;
	range = int(distance(attacker.origin, self.origin));

	if(isDefined(range))
	{
		if(level.ex_obrange == 1)
		{
			rangedist = int(range * 0.02778);		// Range in Yards
	
			if(rangedist > 9) inyards = true;
			else
			{
				close = true;
				rangedesc = &"OBITUARY_CLOSE_RANGE";
			}	
		}
		else
		{
			rangedist = int(range * 0.0254);		// Range in Metres
			
			if(rangedist > 3) inyards = false;
			else close = true;
		}
	}	

	weapon = getweaponstringname(sWeapon);
	hitloc = gethitlocstringname(sHitLoc);

	if(isDefined(rangedist))
	{
		iprintln(&"OBITUARY_KILLED_HITLOC", self.name, hitloc);
		
		if(close)
		{
			iprintln(&"OBITUARY_CLOSE_RANGE", attacker.name);
			iprintln(&"OBITUARY_USING_WEAPON", weapon);
		}
		else
		{
			iprintln(&"OBITUARY_ATTACKER_WEAPON", attacker.name);

			if(inyards) iprintln(&"OBITUARY_YARDS", rangedist);
			else iprintln(&"OBITUARY_METRES", rangedist);
		}
	}
}

killspree(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	if(!isDefined(game[self.name])) game[self.name] = [];
	if(!isDefined(game[self.name]["conseckill"])) game[self.name]["conseckill"] = 0;

	if(!isPlayer(attacker))
	{
		if(game[self.name]["conseckill"] > 0) game[self.name]["conseckill"] = 0;
		game[self.name]["conseckill"]--;
		return;
	}

	if(attacker != self)
	{
		// check for end of a players killing spree	
		if(game[self.name]["conseckill"] >= 5)
		{
			if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay)
			{
				if(self.ex_obmonamsg)
				{
					if(game[self.name]["conseckill"] >= 30)
					{
	  					iprintln(&"KILLSPREE_HAS_SAVED_ALL_OUR_ASSES_FROM", attacker.name);
	  					iprintln(&"KILLSPREE_ANAL_RAPE", self.name);
	  				}
		   			else if(game[self.name]["conseckill"] >= 25)
		   			{
	    				iprintln(&"KILLSPREE_HAS_SAVED_US_ALL_FROM", attacker.name);
	    				iprintln(&"KILLSPREE_UNHOLY", self.name);
	    			}
	   				else if(game[self.name]["conseckill"] >= 20)
	   				{
	   					iprintln(&"KILLSPREE_HAS_STOPPED_THE_UNSTOPPABLE", attacker.name);
	   					iprintln(&"KILLSPREE_CRUSADE", self.name);
	   				}
	   				else if(game[self.name]["conseckill"] >= 15)
	   				{
		    			iprintln(&"KILLSPREE_HAS_STOPPED_THE_UNSTOPPABLE",attacker.name);
		    			iprintln(&"KILLSPREE_UNREAL", self.name);
		    		}
		   			else if(game[self.name]["conseckill"] >= 10)
		   			{
	   					iprintln(&"KILLSPREE_HAS_STOPPED", attacker.name);
	   					iprintln(&"KILLSPREE_FLUKISH", self.name);
	   				}
		   			else if(game[self.name]["conseckill"] >= 5)
		   			{
	   					iprintln(&"KILLSPREE_HAS_STOPPED", attacker.name);
	   					iprintln(&"KILLSPREE_PLURAL", self.name);
	   				}
				}

				if(self.ex_obmonpsound) attacker playLocalSound("nailedhim");
					
				if(self.ex_obmonpsound)
				{
					players = getentarray("player", "classname");
					for(i = 0; i < players.size; i++) if(players[i] != self) players[i] playlocalsound("hallelujah");
				}
   			}
  		}

		// check for a players killers spree
		if(!isDefined(game[attacker.name])) game[attacker.name] = [];
		if(!isDefined(game[attacker.name]["conseckill"])) game[attacker.name]["conseckill"] = 0;
		else if(game[attacker.name]["conseckill"] <= 0) game[attacker.name]["conseckill"] = 0;

		game[attacker.name]["conseckill"]++;
		//attacker.pers["conseckill"]++;
		stp = undefined;
		pmsg = undefined;
		amsg = undefined;

		if(game[attacker.name]["conseckill"] >= 5)
		{
			if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay)
			{
			  	if(game[attacker.name]["conseckill"] == 5)
			  	{
		   			if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_5", attacker.name);
		   			pmsg = &"KILLSPREE_KILLSPREE_PMSG";
		   			stp = "killingspree";
		   		}
			  	else if(game[attacker.name]["conseckill"] == 10)
			  	{
		   			if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_10", attacker.name);
		   			pmsg = &"KILLSPREE_DOMINATING_PMSG";
		   			stp = "dominating";
		   		}
		  		else if(game[attacker.name]["conseckill"] == 15)
		  		{
					if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_15", attacker.name);
					pmsg = &"KILLSPREE_RAMPAGE_PMSG";
					stp = "rampage";
				}
		  		else if(game[attacker.name]["conseckill"] == 20)
		  		{
		   			if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_20", attacker.name);
		   			pmsg = &"KILLSPREE_UNSTOPPABLE_PMSG";
		   			stp = "unstoppable";
		   		}
		  		else if(game[attacker.name]["conseckill"] == 25)
		  		{
		   			if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_25", attacker.name);
		   			pmsg = &"KILLSPREE_MONSTER_KILL_PMSG";
		   			stp = "monsterkill";
		   		}
		  		else if(game[attacker.name]["conseckill"] >= 30)
		  		{
		   			if(self.ex_obmonamsg) iprintln(&"KILLSPREE_MSG_30", attacker.name);

	   				ps = randomInt(100);
	   				if(ps <= 25) { stp = "ultrakill"; if(self.ex_obmonpmsg) pmsg = &"KILLSPREE_ULTRA_KILL_PMSG"; }
	   				if(ps > 25 && ps <= 50) { stp = "godlike"; if(self.ex_obmonpmsg) pmsg = &"KILLSPREE_GODLIKE_PMSG"; }
	   				if(ps > 50 && ps <= 75) { stp = "holyshit"; if(self.ex_obmonpmsg) pmsg = &"KILLSPREE_HOLY_SHIT_PMSG"; }
	   				if(ps > 75) { stp = "slaughter"; if(self.ex_obmonpmsg) pmsg = &"KILLSPREE_SLAUGHTER_PMSG"; }
		   		}
			}
			else if(attacker.pers["team"] == self.pers["team"] && level.ex_teamplay)
		   	{
		   		game[attacker.name]["conseckill"]--;
		   		attacker.pers["conseckill"]--;
			}

			if(self.ex_obmonpmsg && isDefined(pmsg)) attacker iprintlnbold(&"CUSTOM_ADMIN_NAME",pmsg);
			if(self.ex_obmonpsound&& isDefined(stp)) attacker playLocalSound(stp);
   		}
   	}
}

weaponstreak(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	if(!isPlayer(attacker)) return;
	
	if(isDefined(attacker.pers["weaponname"]) && sWeapon == attacker.pers["weaponname"]) attacker.pers["weaponstreak"]++;
	else
	{
		attacker.pers["weaponstreak"] = 1;
		attacker.pers["weaponname"] = sWeapon;
	}

	attacker_weapon = getweaponstringname(attacker.pers["weaponname"]);

	if(attacker.pers["weaponstreak"] >= 5 && self.ex_obmonamsg)
	{
		if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay)
		{
			if(attacker.pers["weaponstreak"] == 5) attacker iprintln(&"WEAPONSTREAK_MSG_5", attacker_weapon);
	   		else if(attacker.pers["weaponstreak"] == 10) iprintln(&"WEAPONSTREAK_MSG_10", attacker.name, attacker_weapon);
	 		else if(attacker.pers["weaponstreak"] == 15) iprintln(&"WEAPONSTREAK_MSG_15", attacker.name, attacker_weapon);
	   		else if(attacker.pers["weaponstreak"] == 20) iprintln(&"WEAPONSTREAK_MSG_20", attacker.name, attacker_weapon);
	   		else if(attacker.pers["weaponstreak"] == 25) iprintln(&"WEAPONSTREAK_MSG_25", attacker.name, attacker_weapon);
	   		else if(attacker.pers["weaponstreak"] == 30) iprintln(&"WEAPONSTREAK_MSG_30", attacker.name, attacker_weapon);
			else if(attacker.pers["weaponstreak"] >= 35)
			{
				iprintln(&"WEAPONSTREAK_MSG_35A", attacker.name, attacker_weapon);
				iprintln(&"WEAPONSTREAK_MSG_35B", attacker.pers["weaponstreak"]);
			}				
   		}
   		else if(attacker.pers["team"] == self.pers["team"] && level.ex_teamplay) attacker.pers["weaponstreak"]--;
	}
}

noobstreak(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	if(!isPlayer(attacker)) return;

	if(isDefined(attacker.pers["weaponname"]) && sWeapon == attacker.pers["weaponname"]) attacker.pers["noobstreak"]++;
	else
	{
		attacker.pers["noobstreak"] = 1;
		attacker.pers["weaponname"] = sWeapon;
	}

	attacker_weapon = getweaponstringname(attacker.pers["weaponname"]);
	attacker.pers["spamkill"] ++;

	if(attacker.pers["noobstreak"] >= 5 && self.ex_obmonamsg)
	{
		if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay)
		{
			if(attacker.pers["noobstreak"] == 5) iprintln(&"NOOBSTREAK_MSG_5", attacker.name, attacker_weapon);
   			else if(attacker.pers["noobstreak"] == 10) iprintln(&"NOOBSTREAK_MSG_10", attacker.name, attacker_weapon);
	 		else if(attacker.pers["noobstreak"] == 15) iprintln(&"NOOBSTREAK_MSG_15", attacker.name, attacker_weapon);
	  		else if(attacker.pers["noobstreak"] == 20) iprintln(&"NOOBSTREAK_MSG_20", attacker.name, attacker_weapon);
	   		else if(attacker.pers["noobstreak"] == 25) iprintln(&"NOOBSTREAK_MSG_25", attacker.name, attacker_weapon);
	   		else if(attacker.pers["noobstreak"] == 30) iprintln(&"NOOBSTREAK_MSG_30", attacker.name, attacker_weapon);
	   		else if(attacker.pers["noobstreak"] >= 35)
	   		{
	   			iprintln(&"NOOBSTREAK_MSG_35A", attacker.name, attacker_weapon);
	   			iprintln(&"NOOBSTREAK_MSG_35B", attacker.pers["noobstreak"]);
	   		}
   		}
   		else if(attacker.pers["team"] == self.pers["team"] && level.ex_teamplay) attacker.pers["noobstreak"]--;
	}
}

consecdeath(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc)
{
	self endon("disconnect");

	if(game[self.name]["conseckill"] > 0) game[self.name]["conseckill"] = 0;
				
	game[self.name]["conseckill"]--;

	if(!isPlayer(attacker)) return;

	if(game[self.name]["conseckill"] <= -5 && self.ex_obmonamsg)
	{
		if(attacker.pers["team"] != self.pers["team"] && level.ex_teamplay || !level.ex_teamplay)
		{
			if(game[self.name]["conseckill"] == -5) iprintln(&"CONSECDEATHS_MSG_5", self.name);
			else if(game[self.name]["conseckill"] == -8) iprintln(&"CONSECDEATHS_MSG_8", self.name);
			else if(game[self.name]["conseckill"] == -10) iprintln(&"CONSECDEATHS_MSG_10", self.name);
			else if(game[self.name]["conseckill"] == -13) iprintln(&"CONSECDEATHS_MSG_13", self.name);
			else if(game[self.name]["conseckill"] <= -16) iprintln(&"CONSECDEATHS_MSG_16", self.name);
		}
	}
}

getmessage(var)
{
	self endon("disconnect");

	if(!isDefined(var)) return undefined;

	msg = [];

	switch(var)
	{
		case "unknown":
			msg[0] = &"OBITUARY_UNKNOWN_MSG_0";
			msg[1] = &"OBITUARY_UNKNOWN_MSG_1";
			msg[2] = &"OBITUARY_UNKNOWN_MSG_2";
			break;

		case "falling":
			msg[0] = &"OBITUARY_FALLING_MSG_0";
			msg[1] = &"OBITUARY_FALLING_MSG_1";
			msg[2] = &"OBITUARY_FALLING_MSG_2";
			break;

		case "plane":
			msg[0] = &"OBITUARY_PLANE_MSG_0";
			msg[1] = &"OBITUARY_PLANE_MSG_1";
			break;

		case "plane_bomb":
			msg[0] = &"OBITUARY_PLANE_BOMB_MSG_0";
			msg[1] = &"OBITUARY_PLANE_BOMB_MSG_1";
			break;

		case "mortar":
			msg[0] = &"OBITUARY_MORTAR_MSG_0";
			msg[1] = &"OBITUARY_MORTAR_MSG_1";
			break;

		case "panzer":
			msg[0] = &"OBITUARY_PANZER_MSG_0";
			msg[1] = &"OBITUARY_PANZER_MSG_1";
			break;

		case "artillery":
			msg[0] = &"OBITUARY_ARTILLERY_MSG_0";
			msg[1] = &"OBITUARY_ARTILLERY_MSG_1";
			break;

		case "artillerytk":
			msg[0] = &"OBITUARY_ARTILLERYTK_MSG_0";
			msg[1] = &"OBITUARY_ARTILLERYTK_MSG_1";
			break;

		case "selfartillery":
			msg[0] = &"OBITUARY_ARTILLERYSELF_MSG_0";
			break;

		case "pmortar":
			msg[0] = &"OBITUARY_PPANZER_MSG_0";
			msg[1] = &"OBITUARY_PPANZER_MSG_1";
			break;

		case "ppanzer":
			msg[0] = &"OBITUARY_PMORTAR_MSG_0";
			msg[1] = &"OBITUARY_PMORTAR_MSG_1";
			break;

		case "mortartk":
			msg[0] = &"OBITUARY_MORTARTK_MSG_0";
			msg[1] = &"OBITUARY_MORTARTK_MSG_1";
			break;

		case "panzertk":
			msg[0] = &"OBITUARY_PANZERTK_MSG_0";
			msg[1] = &"OBITUARY_PANZERTK_MSG_1";
			break;

		case "selfmortar":
			msg[0] = &"OBITUARY_MORTARSELF_MSG_0";
			break;

		case "selfpanzer":
			msg[0] = &"OBITUARY_PANZERSELF_MSG_0";
			break;

		case "pairstrike":
			msg[0] = &"OBITUARY_PAIRSTRIKE_MSG_0";
			msg[1] = &"OBITUARY_PAIRSTRIKE_MSG_1";
			break;

		case "airstriketk":
			msg[0] = &"OBITUARY_AIRSTRIKETK_MSG_0";
			msg[1] = &"OBITUARY_AIRSTRIKETK_MSG_1";
			break;

		case "selfairstrike":
			msg[0] = &"OBITUARY_AIRSTRIKESELF_MSG_0";
			break;

		case "pnapalm":
			msg[0] = &"OBITUARY_PNAPALM_MSG_0";
			msg[1] = &"OBITUARY_PNAPALM_MSG_1";
			break;

		case "napalmtk":
			msg[0] = &"OBITUARY_NAPALMTK_MSG_0";
			msg[1] = &"OBITUARY_NAPALMTK_MSG_1";
			break;

		case "selfnapalm":
			msg[0] = &"OBITUARY_NAPALMSELF_MSG_0";
			break;

		case "explosive":
			msg[0] = &"OBITUARY_EXPLOSIVE_MSG_0";
			msg[1] = &"OBITUARY_EXPLOSIVE_MSG_1";
			break;
			
		case "explosivetk":
			msg[0] = &"OBITUARY_EXPLOSIVETK_MSG_0";
			msg[1] = &"OBITUARY_EXPLOSIVETK_MSG_1";
			break;

		case "minefield":
			msg[0] = &"OBITUARY_MINEFIELD_MSG_0";
			msg[1] = &"OBITUARY_MINEFIELD_MSG_1";
			msg[2] = &"OBITUARY_MINEFIELD_MSG_2";
			break;
		
		case "selfnade":
			msg[0] = &"OBITUARY_SELFNADE_MSG_0";
			msg[1] = &"OBITUARY_SELFNADE_MSG_1";
			break;
			
		case "selfnades":
			msg[0] = &"OBITUARY_SELFNADES_MSG_0";
			msg[1] = &"OBITUARY_SELFNADES_MSG_1";
			break;

		case "bashkill_head":
			msg[0] = &"OBITUARY_BASHKILL_HEAD_MSG";
			break;

		case "bashkill":
			msg[0] = &"OBITUARY_BASHKILL_MSG_0";
			msg[1] = &"OBITUARY_BASHKILL_MSG_1";
			break;
		
		case "bashtk":
			msg[0] = &"OBITUARY_BASHTK_MSG_0";
			msg[1] = &"OBITUARY_BASHTK_MSG_1";
			break;

		case "pistolwhip":
			msg[0] = &"OBITUARY_PISTOL_WHIP";
			break;

		case "knifewhip":
			msg[0] = &"OBITUARY_KNIFE_WHIP";
			break;

		case "pistolwhiptk":
			msg[0] = &"OBITUARY_PISTOL_WHIP_TK";
			break;

		case "knifewhiptk":
			msg[0] = &"OBITUARY_KNIFE_WHIP_TK";
			break;

		case "teamkill":
			msg[0] = &"OBITUARY_TEAMKILL_MSG";
			break;

		case "tripwire":
			msg[0] = &"OBITUARY_TRIPWIRE_MSG_0";
			msg[1] = &"OBITUARY_TRIPWIRE_MSG_1";
			break;

		case "tripwiretk":
			msg[0] = &"OBITUARY_TRIPWIRETK_MSG_0";
			msg[1] = &"OBITUARY_TRIPWIRETK_MSG_1";
			break;

		case "selftripwire":
			msg[0] = &"OBITUARY_TRIPWIRESELF_MSG_0";
			break;
		
		case "headshottk":
			msg[0] = &"OBITUARY_HEADSHOT_TK_MSG_0";
			msg[1] = &"OBITUARY_HEADSHOT_TK_MSG_1";
			break;

		case "snipertk":
			msg[0] = &"OBITUARY_SNIPER_TK_MSG_0";
			msg[1] = &"OBITUARY_SNIPER_TK_MSG_1";
			break;

		default:
			msg[0] = &"OBITUARY_WAS_KILLED_BY";
			break;
		}
	
	wm = randomInt(msg.size);
	return msg[wm];
}

// show personal message
showpmsgs(message)
{
	self endon("disconnect");

	if(!isDefined(message)) return undefined;
	
	pmsg = undefined;
	switch(message)
	{
		case "unknown":
			pmsg = &"OBITUARY_UNKNOWN_PMSG";
			break;

		case "falling":
			pmsg = &"OBITUARY_FALLING_PMSG";
			break;

		case "mortar":
			pmsg = &"OBITUARY_MORTAR_PMSG";
			break;

		case "panzer":
			pmsg = &"OBITUARY_PANZER_PMSG";
			break;

		case "plane":
			pmsg = &"OBITUARY_PLANE_PMSG";
			break;

		case "plane_bomb":
			pmsg = &"OBITUARY_PLANE_BOMB_PMSG";
			break;

		case "artillery":
			pmsg = &"OBITUARY_ARTILLERY_PMSG";
			break;

		case "artillerytk":
			pmsg = &"OBITUARY_ARTILLERYTK_PMSG";
			break;

		case "selfartillery":
			pmsg = &"OBITUARY_ARTILLERYSELF_PMSG";
			break;

		case "pmortar":
			pmsg = &"OBITUARY_MORTAR_PMSG";
			break;

		case "ppanzer":
			pmsg = &"OBITUARY_PANZER_PMSG";
			break;

		case "mortartk":
			pmsg = &"OBITUARY_MORTARTK_PMSG";
			break;

		case "panzertk":
			pmsg = &"OBITUARY_PANZERTK_PMSG";
			break;

		case "selfmortar":
			pmsg = &"OBITUARY_MORTARSELF_PMSG";
			break;

		case "selfpanzer":
			pmsg = &"OBITUARY_PANZERSELF_PMSG";
			break;

		case "pairstrike":
			pmsg = &"OBITUARY_AIRSTRIKE_PMSG";
			break;

		case "airstriketk":
			pmsg = &"OBITUARY_AIRSTRIKETK_PMSG";
			break;

		case "selfairstrike":
			pmsg = &"OBITUARY_AIRSTRIKESELF_PMSG";
			break;

		case "pnapalm":
			pmsg = &"OBITUARY_NAPALM_PMSG";
			break;

		case "napalmtk":
			pmsg = &"OBITUARY_NAPALMTK_PMSG";
			break;

		case "selfnapalm":
			pmsg = &"OBITUARY_NAPALMSELF_PMSG";
			break;

		case "explosive":
			pmsg = &"OBITUARY_EXPLOSIVE_PMSG";
			break;
			
		case "explosivetk":
			pmsg = &"OBITUARY_EXPLOSIVETK_PMSG";
			break;

		case "minefield":
			pmsg = &"OBITUARY_MINEFIELD_PMSG";
			break;
		
		case "selfnade":
			pmsg = &"OBITUARY_SELFNADE_PMSG";
			break;
			
		case "selfnades":
			pmsg = &"OBITUARY_SELFNADES_PMSG";
			break;

		case "pistolwhip":
			pmsg = &"OBITUARY_PISTOL_WHIP_PMSG";
			break;

		case "knifewhip":
			pmsg = &"OBITUARY_KNIFE_WHIP_PMSG";
			break;

		case "pistolwhiptk":
			pmsg = &"OBITUARY_PISTOL_WHIP_TK_MSG";
			break;

		case "knifewhiptk":
			pmsg = &"OBITUARY_KNIFE_WHIP_TK_MSG";
			break;

		case "bashkill_head":
			pmsg = &"OBITUARY_BASHKILL_HEAD_PMSG";
			break;

		case "bashkill":
			pmsg = &"OBITUARY_BASHKILL_PMSG";
			break;
		
		case "bashtk":
			pmsg = &"OBITUARY_BASHTK_PMSG";
			break;

		case "teamkill":
			pmsg = &"OBITUARY_TEAMKILL_PMSG";
			break;

		case "tripwire":
			pmsg = &"OBITUARY_TRIPWIRE_PMSG";
			break;

		case "tripwiretk":
			pmsg = &"OBITUARY_TRIPWIRETK_PMSG";
			break;

		case "selftripwire":
			pmsg = &"OBITUARY_TRIPWIRESELF_PMSG";
			break;
		
		case "headshottk":
			pmsg = &"OBITUARY_HEADSHOT_TK_PMSG";
			break;

		case "snipertk":
			pmsg = &"OBITUARY_SNIPER_TK_PMSG";
			break;

		default:
			return;
	}

	self iprintlnbold(&"CUSTOM_ADMIN_NAME", pmsg);
}

gethitlocstringname(location)
{
	switch(location)
	{
		case "right_hand":			return &"HITLOC_RIGHT_HAND";
		case "left_hand":			return &"HITLOC_LEFT_HAND";
		case "right_arm_upper":		return &"HITLOC_RIGHT_UPPER_ARM";
		case "right_arm_lower":		return &"HITLOC_RIGHT_FOREARM";
		case "left_arm_upper":		return &"HITLOC_LEFT_UPPER_ARM";
		case "left_arm_lower":		return &"HITLOC_LEFT_FOREARM";
		case "head":				return &"HITLOC_HEAD";
		case "neck":				return &"HITLOC_NECK";
		case "right_foot":			return &"HITLOC_RIGHT_FOOT";
		case "left_foot":			return &"HITLOC_LEFT_FOOT";
		case "right_leg_lower":		return &"HITLOC_RIGHT_LOWER_LEG";
		case "left_leg_lower":		return &"HITLOC_LEFT_LOWER_LEG";
		case "right_leg_upper":		return &"HITLOC_RIGHT_UPPER_LEG";
		case "left_leg_upper":		return &"HITLOC_LEFT_UPPER_LEG";
		case "torso_upper":			return &"HITLOC_UPPER_TORSO";
		case "torso_lower":			return &"HITLOC_LOWER_TORSO";
		case "none":				return &"HITLOC_UNKNOWN";
		default:					return location;
	}
}

getweaponstringname(weapon)
{
	switch(weapon)
	{
		// Winchester 1200
		case "winchester1200_mp":    		
		case "winchester1200_grip_mp":     	
		case "winchester1200_reflex_mp":    
			return &"GWEAPON_WINCHESTER1200";
		
		// Uzi
		case "uzi_mp":    
		case "uzi_acog_mp":
		case "uzi_reflex_mp":
		case "uzi_silencer_mp":          
			return &"GWEAPON_UZI";
		
		// Usp
		case "usp_mp":    
		case "usp_silencer_mp":     
			return &"GWEAPON_USP";
		
		// Skorpion
		case "skorpion_mp":    
		case "skorpion_acog_mp":    
		case "skorpion_reflex_mp":   
		case "skorpion_silencer_mp":    
			return &"GWEAPON_SKORPION";
		
		// Saw
		case "saw_mp":
		case "saw_acog_mp":
		case "saw_bipod_crouch_mp":
		case "saw_bipod_prone_mp":      
		case "saw_bispod_stand_mp":
		case "saw_grip_mp":
		case "saw_reflex_mp":    
			return &"GWEAPON_SAW";
		
		// RPG
		case "rpg_mp":    return &"GWEAPON_RPG";
		
		// RPD
		case "rpd_mp":
		case "rpd_acog_mp":
		case "rpd_grip_mp":
		case "rpd__reflex_mp":          
			return &"GWEAPON_RPD";
		
		// Remington 700
		case "remington700_mp": 
		case "remington700_acog_mp":    
			return &"GWEAPON_REMINGTON700";
		
		// P90
		case "p90_mp":
		case "p90_acog_mp":
		case "p90_reflex_mp":
		case "p90_silencer_mp":
			return &"GWEAPON_P90";
		
		// MP5
		case "mp5_mp":    
		case "mp5_acog_mp": 
		case "mp5_reflex_mp": 
		case "mp5_silencer_mp": 
			return &"GWEAPON_MP5";
		
		// MP44
		case "mp44_mp":    return &"GWEAPON_MP44";
		
		// M60E4
		case "m60e4_mp":
		case "m60e4_acog_mp":
		case "m60e4_grip_mp":
		case "m60e4_reflex_mp":        
			return &"GWEAPON_M60E4";
		
		// M40A3
		case "m40a3_mp":
		case "m40a3_acog_mp":     
			return &"GWEAPON_M40A3";
		
		// M4
		case "m4_mp":
		case "m4_acog_mp":
		case "m4_gl_mp":
		case "m4_reflex_mp":
		case "m4_silencer_mp":  
			return &"GWEAPON_M4";
		
		// M21
		case "m21_mp":   
		case "m21_acog_mp":   
			return &"GWEAPON_M21";
		
		// M16
		case "m16_mp":
		case "m16_acog_mp":
		case "m16_gl_mp":
		case "m16_reflex_mp":
		case "m16_silencer_mp":  
			return &"GWEAPON_M16";
		
		// M14
		case "m14_mp":
		case "m14_acog_mp":
		case "m14_gl_mp":
		case "m14_reflex_mp":
		case "m14_silencer_mp":
			return &"GWEAPON_M14";
		
		// M1014
		case "m1014_mp":    
		case "m1014_grip_mp":    
		case "m1014_reflex_mp":    
			return &"GWEAPON_BENELLI";
		
		// GL
		case "gl_mp":    
		case "gl_m4_mp":    
		case "gl_m16_mp":    
		case "gl_m14_mp":    
		case "gl_g36c_mp":    
		case "gl_g3_mp":    
			return &"GWEAPON_M203";
		case "gl_ak47_mp":    return &"GWEAPON_AK47_GP25";
			
		// G36C
		case "g36c_mp":
		case "g36c_acog_mp":
		case "g36c_gl_mp":
		case "g36c_reflex_mp":
		case "g36c_silencer_mp":
			return &"GWEAPON_G36C";
	
		// G3
		case "g3_mp":
		case "g3_acog_mp":
		case "g3_gl_mp":
		case "g3_reflex_mp":
		case "g3_silencer_mp":  	
			return &"GWEAPON_G3";
		
		// Dragnov
		case "dragnov_mp":
		case "dragnov_acog_mp":     
			return &"GWEAPON_DRAGNOV";
		
		// Desert Eagle
		case "deserteagle_mp":    return &"GWEAPON_DESERTEAGLE";
		
		// Desert Eagle Gold
		case "deserteaglegold_mp":    return &"GWEAPON_DESERTEAGLEGOLD";
		
		// Colt 45
		case "colt45_mp": 
		case "colt45_silencer_mp":     
			return &"GWEAPON_COLT45";
		
		// Beretta
		case "beretta_mp":  
		case "beretta_silencer_mp":     
			return &"GWEAPON_BERETTA";
		
		// Barrett 50cal
		case "barrett_mp":  
		case "barrett_acog_mp":     
			return &"GWEAPON_BARRETT";
		
		// AW50
		case "aw50_mp":   
		case "aw50_acog_mp":
			return &"GWEAPON_AW50";
		
		// AT4
		case "at4_mp":    
			return &"GWEAPON_AT4";
		
		// AK47U
		case "ak47u_mp":
		case "ak47u_acog_mp":
		case "ak47u_reflex_mp":
		case "ak47u_silencermp":      
			return &"GWEAPON_AK47U";
		
		// AK47
		case "ak47_mp":
		case "ak47_acog_mp":
		case "ak47_gl_mp":
		case "ak47_reflex_mp":
		case "ak47_silencer_mp":
			return &"GWEAPON_AK47";
		
		// frag grenades
		case "frag_grenade_mp":
		case "frag_grenade_short_mp":
			return &"GWEAPON_M2FRAGGRENADE";

		// Claymore
		case "claymore_mp":
			return &"GWEAPON_CLAYMORE";

		// C4
		case "c4_mp":
			return &"GWEAPON_C4";

		default: return &"GWEAPON_UNKNOWN";
	}
}