#include maps\mp\gametypes\sv_fps;

init()
{
	level.voteMenuDel = [[level.ex_dvardef]]("ex_vote_menu_delay", 0, 0, 9999, "int");

	level.voteMenusDel = level.voteMenuDel/60;

	level.voteLimit	= [[level.ex_dvardef]]("ex_vote_limiter", 0, 0, 2, "int");

	if(level.voteLimit)
	{

		level.voteEnable	= [[level.ex_dvardef]]("ex_vote_enable_time", 120, 0, 9999, "int");
		level.voteEnableMsg	= level.voteEnable/60;
		level.voteDisable	= [[level.ex_dvardef]]("ex_vote_disable_time", 240, 0, 9999, "int");
		level.voteDisableMsg	= level.voteDisable/60;

		thread voteLimiter();
	}

	if(level.voteMenuDel)
	{
		level.voteMenuMsg = level.voteMenusDel;
                if(level.voteLimit == 2)
                thread voteMenuChk();
                else
		thread voteMenuTimer();
	}

}

voteMenuChk()
{
	level.voteMsg = [[level.ex_dvardef]]("ex_vote_msg", 1, 0, 1, "int");

	if(level.voteMenuDel && !isDefined(level.voteTimerDone))
	{
		if(level.voteMenuMsg)
		{
			if(level.voteMsg)
			self iprintln(&"MISC_DELAY", level.voteMenuMsg, &"MISC_MINUTES");
		}
	}
}

voteMenuTimer()
{
	level.voteMsg = [[level.ex_dvardef]]("ex_vote_msg", 1, 0, 1, "int");

	level.voteTimerDone = undefined;
	setdvar("g_allowvote", "0");

	if(level.voteLimit == 2)
	{      
		setdvar("g_allowvote", "1");
		level.voteTimerDone = true;
	}
	else
	wait (level.voteMenuDel * level.fps_multiplier);

	if(level.voteMsg)
	iprintln(&"MISC_ENABLED", level.voteEnableMsg, &"MISC_MINUTES");
             
	setdvar("g_allowvote", "1");
	level.voteTimerDone = true;

}

voteLimiter()
{
	thread setVote(true, true);

	if(level.voteMenuDel)
	{
		if(level.voteLimit == 1)
		{
			while (!isDefined(level.voteTimerDone))
				wait (1 * level.fps_multiplier);
		}
		else
		{
			level.voteTimerDone = true;
		}
	}

	for (;;)
	{ 
		wait (level.voteEnable * level.fps_multiplier);
		thread setVote(false, false);

		wait (level.voteDisable * level.fps_multiplier);
		thread setVote(true, false);

		wait (1 * level.fps_multiplier);
	}
}

setVote(enable, init)
{
	level.voteMsg = [[level.ex_dvardef]]("ex_vote_msg", 1, 0, 1, "int");

	if(enable)
		setdvar("g_allowvote", "1");
	else
		setdvar("g_allowvote", "0");
		wait (1 * level.fps_multiplier);

	if(enable)
	{
		wait (1.5 * level.fps_multiplier);

		if(level.voteEnableMsg && !init)
		{
			if(level.voteMsg)
          		iprintln(&"MISC_ENABLED", level.voteEnableMsg, &"MISC_MINUTES");
		}  
	}
	else
	{
		wait (1.5 * level.fps_multiplier);

		if(level.voteDisableMsg)
		{
			if(level.voteMsg) 
			iprintln(&"MISC_DISABLED", level.voteDisableMsg, &"MISC_MINUTES");
		}
	}
}
